#Copyright 2008 Alexander Exner

#This file is part of WebcamDemo.

#WebcamDemo is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#WebcamDemo is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with WebcamDemo.  If not, see <http://www.gnu.org/licenses/>.

import numpy
import Image
import matrixstuff
#import camutil.getimage
import unittest

class matrixstuffTestCase(unittest.TestCase):
    
    def setUp(self):
        #self.seq = range(10)
        self.matrix1 = numpy.array([0, 0, 1, 2, 3, 4, \
                                    0, 0, 0, 0, 3, 4, \
                                    1, 0, 0, 0, 0, 4])
        self.matrix1.shape = 3, 6
        self.matrix2 = numpy.array([9, 0, 0, 0, 3, 0, \
                                    0, 9, 0, 0, 0, 0, \
                                    0, 0, 9, 0, 0, 0])
        self.matrix2.shape = 3, 6
        self.m_1add2 = numpy.array([9, 0, 1, 2, 6, 4, \
                                    0, 9, 0, 0, 3, 4, \
                                    1, 0, 9, 0, 0, 4])
        self.m_1add2.shape = 3, 6
        self.m_1sub2 = numpy.array([-9, 0, 1, 2, 0, 4, \
                                    0, -9, 0, 0, 3, 4, \
                                    1, 0, -9, 0, 0, 4])
        self.m_1sub2.shape = 3, 6
        #numpy.multiply(matrix1, matrix2) # Hadamard product
        self.i = Image.new("RGB", (4, 5), (10, 128, 230))
        self.i2 = Image.new("RGB", (2, 3), (0, 111, 222))
        self.i.paste(self.i2, (1, 0))
        self.si = self.i.split()
        
    def tearDown(self):
        self.matrix1 = None
        self.matrix2 = None
        self.m_1add2 = None
        self.m_1sub2 = None
        self.i = None
        self.i2 = None
        self.si = None

    def testprintdebug(self):
        dbgstr = matrixstuff.toDebugString(self.matrix1)
        self.assertEqual(dbgstr, "[[0 0 1 2 3 4]\n [0 0 0 0 3 4]\n [1 0 0 0 0 4]]")
        
    def testgetWeightMatrix(self):
        print matrixstuff.toDebugString(matrixstuff.getWeightMatrix(3))

    def testImageToArray(self):
        a0 = matrixstuff.imageToArray(self.si[0])
        a1 = matrixstuff.imageToArray(self.si[1])
        a2 = matrixstuff.imageToArray(self.si[2])
        i0 = matrixstuff.arrayToImage(a0)
        i1 = matrixstuff.arrayToImage(a1)
        i2 = matrixstuff.arrayToImage(a2)
        mi = Image.merge("RGB", (i0, i1, i2))
        #print self.i.size
        #print list(self.i.getdata())
        #print mi.size
        #print list(i0.getdata())
        #print list(i1.getdata())
        #print list(i2.getdata())
        #print list(mi.getdata())
        self.assertEqual(self.i.tostring(), mi.tostring())

if __name__ == '__main__':
    unittest.main()
